// StatView.cpp : implementation of the CStatusBarsView class
//

#include "stdafx.h"
#include "StatBar.h"

#include "StatBDoc.h"
#include "StatView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const COLORREF BLACK=RGB(0,0,0);
const COLORREF RED=RGB(255,0,0);
const COLORREF GREEN=RGB(0,255,0);
const COLORREF BLUE=RGB(0,0,255);

/////////////////////////////////////////////////////////////////////////////
// CStatusBarsView

IMPLEMENT_DYNCREATE(CStatusBarsView, CView)

BEGIN_MESSAGE_MAP(CStatusBarsView, CView)
	//{{AFX_MSG_MAP(CStatusBarsView)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	ON_COMMAND_RANGE(ID_COLORS_BLACK, ID_COLORS_BLUE, OnStandardColors)
	ON_UPDATE_COMMAND_UI_RANGE(ID_COLORS_BLACK, ID_COLORS_BLUE, OnUpdateStandardColors)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStatusBarsView construction/destruction

CStatusBarsView::CStatusBarsView()
{
}

CStatusBarsView::~CStatusBarsView()
{
}

BOOL CStatusBarsView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CStatusBarsView drawing

void CStatusBarsView::OnDraw(CDC* pDC)
{
	CStatusBarsDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	CRect r;
	GetClientRect(&r);
	int x = r.right / 2, y = r.bottom / 2;

	pDC->SetTextColor(pDoc->GetColor());
	pDC->SetTextAlign (TA_CENTER | TA_BASELINE);
	pDC->TextOut (x, y, pDoc->GetPhrase());
}

/////////////////////////////////////////////////////////////////////////////
// CStatusBarsView diagnostics

#ifdef _DEBUG
void CStatusBarsView::AssertValid() const
{
	CView::AssertValid();
}

void CStatusBarsView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CStatusBarsDoc* CStatusBarsView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CStatusBarsDoc)));
	return (CStatusBarsDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CStatusBarsView message handlers
void CStatusBarsView::OnStandardColors(UINT nID)
{
	CStatusBarsDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->SetColor(IDtoColorRef(nID));
	Invalidate();
}

void CStatusBarsView::OnUpdateStandardColors(CCmdUI* pCmdUI)
{
	CStatusBarsDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pCmdUI->SetCheck(pDoc->GetColor() == IDtoColorRef(pCmdUI->m_nID));
}

// This function converts one of the 4 Command IDs to a COLORREF value.
COLORREF CStatusBarsView::IDtoColorRef(int nID)
{
	switch (nID)
	{
		case ID_COLORS_RED:
			return RED;
		case ID_COLORS_GREEN:
			return GREEN;		
		case ID_COLORS_BLUE:
			return BLUE;
		default:
			return BLACK;		
	}
}
