// ToolView.cpp : implementation of the CToolView class
//

#include "stdafx.h"
#include "Tool.h"

#include "ToolDoc.h"
#include "ToolView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const COLORREF BLACK=RGB(0,0,0);
const COLORREF RED=RGB(255,0,0);
const COLORREF GREEN=RGB(0,255,0);
const COLORREF BLUE=RGB(0,0,255);

/////////////////////////////////////////////////////////////////////////////
// CToolView

IMPLEMENT_DYNCREATE(CToolView, CView)

BEGIN_MESSAGE_MAP(CToolView, CView)
	//{{AFX_MSG_MAP(CToolView)
	ON_COMMAND(ID_COLORS_BLACK, OnColorsBlack)
	ON_COMMAND(ID_COLORS_BLUE, OnColorsBlue)
	ON_COMMAND(ID_COLORS_GREEN, OnColorsGreen)
	ON_COMMAND(ID_COLORS_RED, OnColorsRed)
	ON_UPDATE_COMMAND_UI(ID_COLORS_BLACK, OnUpdateColorsBlack)
	ON_UPDATE_COMMAND_UI(ID_COLORS_BLUE, OnUpdateColorsBlue)
	ON_UPDATE_COMMAND_UI(ID_COLORS_GREEN, OnUpdateColorsGreen)
	ON_UPDATE_COMMAND_UI(ID_COLORS_RED, OnUpdateColorsRed)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CToolView construction/destruction

CToolView::CToolView()
{
}

CToolView::~CToolView()
{
}

BOOL CToolView::PreCreateWindow(CREATESTRUCT& cs)
{
	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CToolView drawing

void CToolView::OnDraw(CDC* pDC)
{
	CToolDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	CRect r;
	GetClientRect(&r);
	int x = r.right / 2, y = r.bottom / 2;

	pDC->SetTextColor(pDoc->GetColor());
	pDC->SetTextAlign (TA_CENTER | TA_BASELINE);
	pDC->TextOut (x, y, pDoc->GetPhrase());
}

/////////////////////////////////////////////////////////////////////////////
// CToolView diagnostics

#ifdef _DEBUG
void CToolView::AssertValid() const
{
	CView::AssertValid();
}

void CToolView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CToolDoc* CToolView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CToolDoc)));
	return (CToolDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CToolView message handlers


void CToolView::OnColorsBlack() 
{
	CToolDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->SetColor(BLACK);
	Invalidate();
}

void CToolView::OnColorsBlue() 
{
	CToolDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	
	pDoc->SetColor(BLUE);
	Invalidate();
}

void CToolView::OnColorsGreen() 
{
	CToolDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->SetColor(GREEN);
	Invalidate();
}

void CToolView::OnColorsRed() 
{
	CToolDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pDoc->SetColor(RED);
	Invalidate();
}

void CToolView::OnUpdateColorsBlack(CCmdUI* pCmdUI) 
{
	CToolDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pCmdUI->Enable(pDoc->GetColor() != BLACK);
}

void CToolView::OnUpdateColorsBlue(CCmdUI* pCmdUI) 
{
	CToolDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pCmdUI->Enable(pDoc->GetColor() != BLUE);
}

void CToolView::OnUpdateColorsGreen(CCmdUI* pCmdUI) 
{
	CToolDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pCmdUI->Enable(pDoc->GetColor() != GREEN);
}

void CToolView::OnUpdateColorsRed(CCmdUI* pCmdUI) 
{
	CToolDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	pCmdUI->Enable(pDoc->GetColor() != RED);
}
